' === Hser20X2IntIndirect.bas ==========================================
' Demonstrate the increased power of the 20X2 hardware serial commands.

' Your terminal program should be set for 115200 baud, line mode, with
' local echo turned on. Also, Connect TxD on USB cable to 20X2 hserin
' pin (B.6), and connect RxD on USB cable to 20X2 hserout pin (C.0)

' Note: On the 20M2, the A.0 pin is "undocumented," but on the 20X2,
' pin A.0 is in fact "documented." (See the 20X2 pinout.) As a result,
' we can use a symbol command to declare a name for the A.0 pin.

' === Directives ===
  #com 4                            'specify serial port
  #picaxe 20X2                      'specify processor
  #terminal off                     'disable terminal window
  #no_table                         'save time downloading

' === Constants ===
  symbol  LED = A.0                 'debugging LED on pin A.0

' === Begin Main =======================================================
' hsersetup: background receive, true serial, hserin & hserout enabled
' (Don't forget: the 20X2 defaults to 8MHz clock, not 4MHz)
  hsersetup B115200_8, %00001

' setintflags: interrupt occurs when hserflag (bit5 of flags) = 1
  setintflags %00100000, %00100000

  do	
    toggle LED                      'pretend to be busy
    wait 2                          'two second delay
  loop

' === End Main - Subroutines Follow ====================================
interrupt:
  setintflags off                   'disable interupts
  pause 15                          'allow time to receive all data
  dec hserinptr                     'get loc of last character received
  
  for ptr = 0 to hserinptr          'for each stored data byte
    hserout 0, (@ptr)               'echo it back to CoolTerm
  next ptr

  hserout 0, (cr,lf)                'move down 1 line in terminal

  hserinflag = 0                    'reset the new background data flag
  hserinptr = 0                     'reset the data write pointer to 0
  setintflags %00100000, %00100000  're-enable the interrupt
  return